config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  scope '(:locale)', locale: /#{I18n.available_locales.join('|')}/ do
    root 'static_pages#home'

    get '/home' => 'static_pages#home'
    get '/venue' => 'static_pages#venue'
    get '/schedule' => 'static_pages#schedule'
    get '/under_construction' => 'static_pages#under_construction'

    resources :guests

    post '/guests/email_all' => 'guests#email_all'

    # Clearance routes
    resources :passwords,
      controller: 'clearance/passwords',
      only: [:create, :new]

    resource :session,
      controller: 'sessions',
      only: [:create] 

    resources :users,
      controller: 'clearance/users',
      only: Clearance.configuration.user_actions do
        resource :password,
        controller: 'clearance/passwords',
        only: [:create, :edit, :update]
      end

    get '/sign_in' => 'sessions#new', as: 'sign_in'
    delete '/sign_out' => 'sessions#destroy', as: 'sign_out'

  end

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/guest.rb
class Guest < ApplicationRecord
  enum rsvp: %i[unknown yes no]
end

app/models/user.rb
# frozen_string_literal: true

class User < ApplicationRecord
  include Clearance::User
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
  include Clearance::Controller
  protect_from_forgery with: :exception

  before_action :set_locale

  def set_locale
    I18n.locale = params[:locale] || session[:locale] || I18n.default_locale
    session[:locale] = I18n.locale
  end

  def default_url_options
    { locale: I18n.locale }
  end
end

app/controllers/guests_controller.rb
class GuestsController < ApplicationController
  before_action :require_login

  def index
    @guests = Guest.all.order(:last_name)
  end

  def new
    @guest = Guest.new
  end

  def create
    @guest = Guest.new(guest_params)
    if @guest.save
      # TODO: show success flash (#40)
      update_guest_partner(@guest)
      redirect_to guests_path
    else
      render 'new'
    end
  end

  def edit
    @guest = Guest.find(params[:id])
  end

  def update
    @guest = Guest.find(params[:id])
    # TODO: this should be one transaction
    remove_partner_from_guest(@guest.partner_id) if guest_params[:partner_id] != @guest.partner_id

    if @guest.update_attributes(guest_params)
      # TODO: show success flash (#40)
      update_guest_partner(@guest)
      redirect_to guests_path
    else
      render 'edit'
    end
  end

  def email_all
    # TODO: get name of email as param

    Guest.all.each do |guest|
      I18n.with_locale(guest.language) do
        GuestMailer.with(guest: guest).save_the_date.deliver_later
      end
    end
  end

  private

    # Accepting only safe parameters in the POST/PATCH requests
    def guest_params
      guest_params = params.require(:guest)
                           .permit(:first_name, :last_name, :email, :language,
                                   :rsvp, :has_partner, :partner_id, :notes)

      if guest_params[:has_partner] == 'false'
        guest_params[:partner_id] = '0'
        # TODO: Add a string to be displayed in a warning flash (#40) if ID wasn't
        # 0 previously
      end
      guest_params
    end

    def update_guest_partner(guest)
      return if !guest.has_partner || guest.partner_id.zero?

      partner = Guest.find(guest.partner_id)

      if partner.has_partner?
        # Error - can't choose as partner somebody who already has one
        # Shouldn't happen from the UI
      else
        # TODO: Error handling when partner can't be found or updated
        partner.update(has_partner: true, partner_id: guest.id) unless partner.nil?
      end
    end

    def remove_partner_from_guest(guest_id)
      return if guest_id.zero?

      guest = Guest.find(guest_id)
      guest.update(has_partner: false, partner_id: 0)
    end
end

app/controllers/sessions_controller.rb
# frozen_string_literal: true

class SessionsController < Clearance::SessionsController
  # Default behavior - just added remember_token cookie
  # https://github.com/thoughtbot/clearance/blob/53107d90d37d238ee59a7297aa564027ce63c39a/app/controllers/clearance/sessions_controller.rb#L5-L16
  def create
    @user = authenticate(params)

    sign_in(@user) do |status|
      if status.success?
        # Not sure why this isn't the case by default...
        # https://stackoverflow.com/a/9545814/3898322
        cookies['remember_token'] = @user.remember_token
        redirect_back_or url_after_create
      else
        flash.now.alert = status.failure_message
        render template: 'sessions/new', status: :unauthorized
      end
    end
  end

  def url_after_destroy
    root_url
  end
end

app/controllers/static_pages_controller.rb
# frozen_string_literal: true

class StaticPagesController < ApplicationController
  def home; end

  def venue; end

  def schedule; end

  def under_construction; end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
  # https://github.com/thewca/worldcubeassociation.org/blob/c05b272fc0c8cef14d465df12c7b6c6a0da3779f/WcaOnRails/app/helpers/application_helper.rb#L202
  def flag_icon(iso2, html_options = {})
    html_options[:class] ||= ''
    html_options[:class] += " flag-icon flag-icon-#{iso2.downcase}"
    content_tag :span, '', html_options
  end
end

app/helpers/guests_helper.rb
module GuestsHelper
  def language_options(guest)
    selected_option = guest.language.nil? ? 'en' : guest.language
    # TODO: Get options from locales file
    options_for_select(%w[fr en], selected_option)
  end

  def rsvp_options(guest)
    selected_option = guest.rsvp.nil? ? 'unknown' : guest.rsvp
    # TODO: Get options from Guest model
    options_for_select(%w[unknown yes no], selected_option)
  end

  def partner_options(guest)
    sorted_single_guests = Guest.all.reject(&:has_partner?).sort_by(&:last_name)

    guests_to_display = get_partner_dropdown(guest, sorted_single_guests)

    all_guest_options = guests_to_display.map do |g|
      ["#{g.first_name} #{g.last_name}", g.id]
    end

    all_options = [['Unknown', 0]] + all_guest_options
    options_for_select(all_options, guest.partner_id)
  end

  private

    def get_partner_dropdown(guest, sorted_single_guests)
      if !guest.partner_id.nil? && guest.partner_id > 0
        current_partner = Guest.find(guest.partner_id)
        guests_to_display = [current_partner] + sorted_single_guests
      else
        guests_to_display = sorted_single_guests
      end
      guests_to_display
    end
end

app/helpers/static_pages_helper.rb
# frozen_string_literal: true

module StaticPagesHelper
end

app/views/guests/_form.html.erb
<%= form_for(@guest) do |f| %>
  <div class="container">
    <div class="row">
      <div class="col-md-6">
        <%= f.label :first_name %>
        <%= f.text_field :first_name %>

        <%= f.label :last_name %>
        <%= f.text_field :last_name %>

        <%= f.label :email %>
        <%= f.email_field :email %>

        <%= f.label :language %>
        <%= f.select(:language, language_options(@guest)) %>

        <%= f.label :rsvp %>
        <%= f.select(:rsvp, rsvp_options(@guest)) %>

        <%= f.label :has_partner %>
        <%= f.check_box :has_partner %> 

        <%= f.label 'Select partner' %>
        <%= f.select(:partner_id, partner_options(@guest)) %>
      </div>

      <div class="col-md-6">
        <%= f.label :notes %>
        <!-- TODO: Use CSS to define correct height -->
        <%= f.text_area :notes, rows: 18 %>
      </div>
    </div>

    <div class="row">
      <%= f.submit @guest.email.nil? ? t('guests.create_guest') : t('guests.update_guest'), class: 'btn btn-primary' %>
    </div>
  </div>
<% end %>

app/views/guests/edit.html.erb
<% provide(:title, t('guests.edit_guest')) %>
<h1><%= t('guests.edit_guest') %></h1>

<%= render 'form' %>
</div>

app/views/guests/index.html.erb
<% provide(:title, t('guests.title')) %>
<div>
  <h1>
    <%= link_to (fa_icon 'mail-bulk'), { action: 'email_all', controller: '/guests' }, class: 'guest-button', id: 'email-all-guests-button', title: t('guests.email_all_guests'), method: :post , :data => {:confirm => t('guests.email_guests_confirmation')}%>
    <%= t('guests.title') %>
    <%= link_to (fa_icon 'plus-circle'), new_guest_path, class: 'guest-button', id: 'new-guest-button', title: t('guests.new_guest') %>
  </h1>
</div>
<div>
  <table class="table table-striped table-hover">
    <tr>
      <th><%= t('guests.first_name') %></th>
      <th><%= t('guests.last_name') %></th>
      <th><%= t('guests.email') %></th>
      <th><%= t('guests.language') %></th>
      <th><%= t('guests.rsvp') %></th>
      <th></th>
    </tr>
    <% @guests.each do |guest| %>
      <tr>
        <td><%= guest.first_name %></td>
        <td><%= guest.last_name %></td>
        <td><%= guest.email %></td>
        <td><%= guest.language %></td>
        <td><%= t("rsvp_status.#{guest.rsvp}") %></td>
        <td><%= link_to (fa_icon 'user-edit'), edit_guest_path(guest), class: 'guest-button', title: t('guests.edit_guest') %></td>
      </tr>
    <% end %>
 </table> 
</div>

app/views/guests/new.html.erb
<% provide(:title, t('guests.new_guest')) %>
<h1><%= t('guests.new_guest') %></h1>

<%= render 'form' %>
</div>

app/views/layouts/_navigation.html.erb
<nav class='navbar navbar-expand-md bg-dark navbar-dark'>
  <div class='container'>
    <!-- Brand -->
    <a><%= link_to image_tag('emoji-couple-with-heart.png'), { action: 'home', controller: '/static_pages' }, class: 'navbar-brand', style: 'display: inline-block' %></a>

    <!-- Toggler/collapsibe Button -->
    <button class='navbar-toggler' type='button' data-toggle='collapse' data-target='#collapsibleNavbar'>
      <span class='navbar-toggler-icon'></span>
    </button>

    <!-- Navbar links -->
    <div class='collapse navbar-collapse' id='collapsibleNavbar'>
      <ul class='navbar-nav'>
        <li><%= link_to t('navigation.home'), { action: 'home', controller: '/static_pages' }, class: 'nav-link' %></li>
        <li><%= link_to t('navigation.schedule'), { action: 'schedule', controller: '/static_pages' }, class: 'nav-link' %></li>
        <li><%= link_to t('navigation.venue'), { action: 'venue', controller: '/static_pages' }, class: 'nav-link' %></li>
        <% if signed_in? %>
          <li><%= link_to t('navigation.guests'), { action: 'index', controller: '/guests' }, class: 'nav-link' %></li>
        <% end %>
      </ul>
      <ul class='navbar-nav ml-auto'>
        <li class='nav-item dropdown'>
          <a href='#' class='nav-link dropdown-toggle ml-4 mx-sm-2 my-2 my-sm-auto' data-toggle='dropdown' data-hover='dropdown'>
            <% active_locale_info = Locales::AVAILABLE[I18n.locale] %>
            <%= flag_icon(active_locale_info[:flag_id]) %>
            <span class='caret'></span>
          </a>
          <div class='dropdown-menu' role='menu'>
            <% Locales::AVAILABLE.each do |l, data| %>
              <%= link_to flag_icon(data[:flag_id]), url_for(locale: l), class: 'nav-link dropdown-item' %>
            <% end %>
          </li>
        </div>
      </ul>
    </div>
  </div>
</nav> 

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title><%= yield(:title) %> | <%= t('application.title') %></title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <%= csrf_meta_tags %>
    <%= favicon_link_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= render 'layouts/navigation' %>
    <div class='container text-center'>
      <%= yield %>
    </div>
  </body>

  <footer class='footer container-fluid text-center'>
    <%= link_to (fa_icon('gitlab', type: :brand)), 'https://gitlab.com/kevin.guillaumond/weddingwebsite', target: :_blank, rel: 'noopener noreferrer' %>
    <% if signed_in? %>
      <%= link_to (fa_icon 'sign-out-alt'), sign_out_path, method: :delete %>
    <% else %>
      <%= link_to (fa_icon 'sign-in-alt'), sign_in_path %>
    <% end %>
  </footer>

  <%= debug(params) if Rails.env.development? %>
</html>

app/views/static_pages/home.html.erb
<% provide(:title, t('home.title')) %>
<h1>#EatDrinkBeMarried</h1>
<p><%= t('home.text') %></p>

app/views/static_pages/schedule.html.erb
<% provide(:title, t('schedule.title')) %>
<p><%= t('schedule.text') %></p>

app/views/static_pages/under_construction.html.erb
<% provide(:title, t('under_construction.title')) %>
<h1><%= t('under_construction.title') %></h1>
<p><%= t('under_construction.text') %></p>
<p><%= image_tag('under_construction.jpg', :class => 'under-construction-image') %></p>

app/views/static_pages/venue.html.erb
<% provide(:title, t('venue.title')) %>
<p><%= t('venue.text') %></p>